#include "qkurvenanalyse.h"

QKurvenAnalyseDlg::QKurvenAnalyseDlg(QWidget *parent) :  QDialog(parent){
  this->resize(300,100);
  this->setMinimumSize(0,0);
  this->setWindowTitle(tr("Analyse der Wobbelkurven-Spur","Kurvenspur Dialog"));
  buttonok = new QPushButton("SET",this);
  buttonok->setGeometry(200,50,80,30);
  connect(buttonok, SIGNAL(clicked()), SLOT(accept()));
  buttonabbruch = new QPushButton("Abbruch",this);
  buttonabbruch->setGeometry(200,20,80,30);
  connect(buttonabbruch, SIGNAL(clicked()), SLOT(close()));
  sbkurven = new QSpinBox(this);
  connect(sbkurven, SIGNAL(valueChanged(int)), SLOT(setSpur(int)));
  sbkurven->setGeometry(10,35,50,30);
  sbkurven->setRange(0,spurmax-1);
  labelkurven = new QLabel(tr("Spur Nummer","Kurvenspur Dialog"),this);
  labelkurven->setGeometry(70,35,150,30);
}

void QKurvenAnalyseDlg::setMesskurve(const TMessKurve & dmk){
  smesskurve = dmk;
  int s=0;
  //Anzahl der Spuren ermitteln
  for(int i=0;i<spurmax;i++){
    if(smesskurve.bdbsp[i])s=i;
  }
  sbkurven->setMaximum(s);
  sbkurven->setValue(s);
  //qDebug()<<"Kurvenspur: "<<smesskurve.dbspidx;
}

TMessKurve QKurvenAnalyseDlg::getMesskurve(){
  return smesskurve;
}

void QKurvenAnalyseDlg::setSpur(int i){
  int spur=i;
  if(smesskurve.bdbsp[spur]){
    //qDebug()<<"Spur: "<<spur;
    TMessKurve mkmerk;
    /*
    for(int i=0;i<smesskurve.mpunkte;i++){
      mkmerk.dbk1[i]=smesskurve.dbk1[i];
    }
    for(int i=0;i<smesskurve.mpunkte;i++){
      smesskurve.dbk1[i]=smesskurve.dbsp[spur][i];
    }
    */
    for(int i=0;i<smesskurve.mpunkte;i++){
      smesskurve.dbk1[i]=smesskurve.dbsp[spur][i];
    }
    emit DisplayMesskurve(smesskurve);
  }
}
